﻿using System.Globalization;
using ThinkGeo.MapSuite.WpfDesktopEdition;

namespace ThinkGeo.MapSuite.WmsServiceClient
{
    public class MainWindowViewModel : ViewModelBase
    {
        private string coordinateY;
        private string coordinateX;
        private MapModel mapModel;
        private WpfMap mapControl;

        public MainWindowViewModel()
            : this(null)
        {
        }

        public MainWindowViewModel(WpfMap wpfMap)
        {
            MapControl = wpfMap;
            MapControl.MapTools.MouseCoordinate.CustomFormatted += MouseCoordinate_CustomFormatted;
        }

        public WpfMap MapControl
        {
            get { return mapControl; }
            set
            {
                mapControl = value;
                mapModel = new MapModel(value);
            }
        }

        public string CoordinateX
        {
            get { return coordinateX; }
            set
            {
                coordinateX = value;
                RaisePropertyChanged(() => CoordinateX);
            }
        }

        public string CoordinateY
        {
            get { return coordinateY; }
            set
            {
                coordinateY = value;
                RaisePropertyChanged(() => CoordinateY);
            }
        }

        private void MouseCoordinate_CustomFormatted(object sender, CustomFormattedMouseCoordinateMapToolEventArgs e)
        {
            string format = "N6";
            CoordinateX = e.WorldCoordinate.X.ToString(format, CultureInfo.InvariantCulture);
            CoordinateY = e.WorldCoordinate.Y.ToString(format, CultureInfo.InvariantCulture);
        }
    }
}