﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using ThinkGeo.MapSuite.Core;

namespace ThinkGeo.MapSuite.WorldMapPlugins
{
    public static class InternalHelper
    {
        public static string ConvertFeaturesToJson(IEnumerable<Feature> features)
        {
            Collection<SerializableFeature> jsonFeatures = new Collection<SerializableFeature>();
            foreach (Feature feature in features)
            {
                SerializableFeature jsonFeature = new SerializableFeature();
                jsonFeature.Id = feature.Id;
                jsonFeature.Wkt = feature.GetWellKnownText();
                jsonFeature.RealFeature = feature;
                foreach (var column in feature.ColumnValues)
                {
                    jsonFeature.ColumnValues.Add(column.Key, column.Value);
                }
                jsonFeatures.Add(jsonFeature);
            }

            return JsonSerializer.Serialize<Collection<SerializableFeature>>(jsonFeatures);
        }
    }
}
